/**
  *  \file client/chart/standardmode.h
  *  \brief Starchart Mode: WStandardChartMode
  *
  *  (c) 2001-2022 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_CHART_STANDARDMODE_H
#define PCC_V2_CLIENT_CHART_STANDARDMODE_H

#include "client/chartmode.h"
#include "client/chart/tilecontainer.h"
#include "game/rangeset.h"

/** Standard starchart mode. This provides a cursor display as well as
    standard map information overlays. */
class WStandardChartMode : public WChartMode {
    int cursor_angle;

    GRangeSet ranges;

    WStarchartTileContainer* overlays;
 public:
    WStandardChartMode();
    ~WStandardChartMode();
    void onMove(GChartLocation& loc);
    void drawBelow(GfxCanvas& can, GChartLocation& loc);
    void drawCursor(GfxCanvas& can, GChartLocation& loc);
    void drawOverlays(GfxCanvas& can, GChartLocation& loc);
    bool handleEvent(const UIEvent& event, GChartLocation& loc);
};

#endif
