/**
  *  \file game/utilmsg.h
  *
  *  (c) 2001-2022 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_GAME_UTILMSG_H
#define PCC_V2_GAME_UTILMSG_H

#include "game/utilread.h"
#include "cpluslib/ptrvector.h"

class GSimpleMailbox;

class GUtilMessageParser {
 public:
    GUtilMessageParser();
    ~GUtilMessageParser();

    void loadDefinition(Stream& in);

    void loadFile(Stream& in, GSimpleMailbox& out);

 private:
    struct Description {
        int id;
        int alias;
        int loop_size;
        int fixed_size;
        string_t name;
        string_t header;
        int load_limit;
        string_t text;
    };
    ptr_vector<Description> util_descs;

    const Description* getDescriptionById(int id) const;

    void addRecord(GSimpleMailbox& out, int rec_id, std::size_t size, const char data[]);
    string_t decodeRecord(const char data[], size_t size, const string_t& tpl);

};

#endif
