/**
  *  \file u/t_util_plugin.cc
  *  \brief Tests for util/plugin.cc
  *
  *  (c) 2001-2022 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "util/plugin.h"
#include "u/t_util.h"

void
UtilPluginTestSuite::testVersion()
{
    TS_ASSERT( compareVersions("1.0", "1.0.1"));
    TS_ASSERT(!compareVersions("1.0.1", "1.0"));

    TS_ASSERT(!compareVersions("1.0", "1.0"));

    TS_ASSERT( compareVersions("1.0", "1.0a"));
    TS_ASSERT(!compareVersions("1.0a", "1.0"));

    TS_ASSERT( compareVersions("a", "b"));
    TS_ASSERT(!compareVersions("b", "a"));

    TS_ASSERT( compareVersions("a", "1"));
    TS_ASSERT(!compareVersions("1", "a"));

    TS_ASSERT( compareVersions("99", "100"));
    TS_ASSERT(!compareVersions("100", "99"));
}
